#include "DxLib.h"
#include "Map.h"

#define	UP		0
#define DOWN	1
#define	LEFT	2
#define	RIGHT	3
//enum Angle{UP,DOWN,LEFT,RIGHT,UNKNOWN};

// O[oϐ>_<
int gPacman[50];			// pbN}̃OtBbNnh
int gMapChip[20];			// }bv`bṽnh
int gBg;					// wĩnh
int gScore;					// _

Map map;


// 摜̓ǂݍ
int LoadData()
{
// 摜̓ǂݍ
	if(LoadDivGraph("pacman.bmp",50, 10, 5, 48, 48, gPacman)==-1) {
		MessageBox(NULL,"pacman.bmp","ReadError",MB_OK);
		return -1;
	}
	if(LoadDivGraph("mapchip1.bmp", 20, 10, 2, 16, 16, gMapChip)==-1) {
		MessageBox(NULL,"mapchip1.bmp","ReadError",MB_OK);
		return -1;
	}
	gBg = LoadGraph("bg1.jpg");


	return 0;
}


// 
int Init()
{
//	ChangeWindowMode(TRUE);				// EChE[hŋN
										//	SʋN(Rg)̂ق쑬x͈肷
//	SetUse3DFlag(FALSE);				// Rc֐FgpȂ
	if(DxLib_Init() == -1) return -1;

	SetDrawScreen( DX_SCREEN_BACK);		// ʂɏ݂܂錾
	SetTransColor(0,0,255);

	if(LoadData()==-1) {
		DxLib_End();
		return -1;
	}
	map.LoadFile("StageData.txt");

	// Q[̐ݒ
	gScore = 0;
	return 0;
}
void ClearEvent()
{
	ScreenFlip();
	MessageBox(NULL,"߂ł","Congratulation",MB_OK);
	return;
}
// }bvzuit[`j
int MapSet()
{
	int sx,sy,st;
	int dot = 0;
	
	DrawGraph(0,0,gBg,FALSE);
	for(sy=0;sy<30;sy++){
		for(sx=0;sx<32;sx++){
			st = map.Get(sx,sy);
			DrawGraph(sx*16,sy*16,gMapChip[st],TRUE);
			if(st == 1 || st == 2) dot++; 
		}
	}
	if( dot == 0 ){		// ĤׂcĂȂ
		ClearEvent();	// NAłA炢˂撣˂
		return -1;
	}
	return 0;
}

// pNjړ֐
int PakuoMove()
{
	static int s = 0;			// pNj\p
	static int x=15, y=19;		// }bvW
	static int dx = 0, dy = 0;	// ͗^Ȃ
	static int Angle = LEFT;
	static int mv = 0;			// pNjړ
	int mvx=0,mvy=0;
	int tw = 0;					// ǔ

	int key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );
	if(key & PAD_INPUT_START) return -1;		// PAD_INPUT_START  [ESC]Key

	if(mv == 0){
		if(map.Get(x,y)==1){
			// SounduςIIv
			gScore +=10;
			map.DotEat(x,y);
		}
		if(map.Get(x,y)==2){
			// nCp[II
			gScore +=50;
			map.DotEat(x,y);
		}
		// ҂}XڂɂƂL[͔
		mv=16;
		tw = map.CheckWall(x,y);		// ͂̕Ǐ󋵔
		if(key & PAD_INPUT_UP){
			if((tw & WALL_UP)==0){
				dx =  0; dy = -1; Angle = UP;
			}
		}else if(key & PAD_INPUT_DOWN){
			if((tw & WALL_DOWN)==0){
				dx =  0; dy =  1; Angle = DOWN;
			}
		} else if(key & PAD_INPUT_LEFT){
			if((tw & WALL_LEFT)==0){
				dx = -1; dy =  0; Angle = LEFT;
			}
		} else if(key & PAD_INPUT_RIGHT){
			if((tw & WALL_RIGHT)==0){
				dx =  1; dy =  0; Angle = RIGHT;
			}
		} else {	// L[͂ȂƂ蔻
			if(((dy==-1)&&(tw&WALL_UP))||((dy==1)&&(tw&WALL_DOWN))
				||((dx==-1)&&(tw&WALL_LEFT))||((dx==1)&&(tw&WALL_RIGHT)))
			{
				dx=0; dy=0;mv=0;
			} else {
				mv = 16;
			}
		}
	} else {
		// pNjړi}Xڂ̒ԂɂƂj
		mv-=4;
		if(mv<=0){
			x+=dx;
			y+=dy;
			mv= 0;
			tw = map.CheckWall(x,y);
			// ǂɂԂƂAvDŋȂ锻
			if((dy==-1)&&(tw&WALL_UP)){
				if( !(tw&WALL_RIGHT)){ dx=1; dy=0; Angle = RIGHT;}
				else if( !(tw&WALL_LEFT)){ dx = -1; dy = 0; Angle = LEFT;}
				else { dx = 0; dy = 0; } // ~
			} else if((dy==1)&&(tw&WALL_DOWN)){
				if( !(tw&WALL_LEFT)){ dx = -1; dy = 0; Angle = LEFT;}
				else if( !(tw&WALL_RIGHT)) { dx = 1; dy = 0; Angle = RIGHT;}
				else { dx = 0; dy = 0; }
			} else if((dx==-1)&&(tw&WALL_LEFT)){
				if( !(tw&WALL_UP)){ dx = 0; dy = -1; Angle = UP;}
				else if( !(tw&WALL_DOWN)){ dx = 0; dy = 1; Angle = DOWN;}
				else { dx = 0; dy = 0; }
			} else if((dx==1)&&(tw&WALL_RIGHT)){
				if( !(tw&WALL_DOWN)){ dx = 0; dy = 1; Angle = DOWN;}
				else if( !(tw&WALL_UP)){ dx = 0; dy = -1; Angle = UP;}
				else { dx = 0; dy = 0;}
			}
		} else {
			mvx=(16-mv)*dx;
			mvy=(16-mv)*dy;
		}
	}
	if((dx+dy)!=0) s = (++s)%6; // ĂƂAj[V

	DrawGraph((x-1)*16+mvx, (y-1)*16+mvy,gPacman[Angle*10+s],TRUE);

	return 0;
}
// C[v
void MainLoop()
{
	while(ProcessMessage()==0){
		ClsDrawScreen();

		if(MapSet())return;
		if(PakuoMove()) return;

		DrawFormatString(512,0,RGB(255,255,255),"SCORE:");
		DrawFormatString(512,16,RGB(255,255,255),"%6d",gScore);

		ScreenFlip();
	}
	return;
}

int WINAPI WinMain(HINSTANCE hI,HINSTANCE hP, LPSTR lpC, int nC)
{
	if(Init()) return -1;	// 

	MainLoop();				// C[`

	DxLib_End();			// Ƃ܂
	return 0;
}